<?php

namespace OrganizationsManagement\Service;

use Doctrine\ORM\EntityManager;
use OrganizationsManagement\Repository\Notice as NoticeRepository;
use OrganizationsManagement\Util\InstanceProvider;

class Notice
{
    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var NoticeRepository
     */
    private $noticeRepository;

    /**
     * Notice constructor.
     * @param EntityManager $entityManager
     * @param NoticeRepository $NoticeRepository
     */
    public function __construct(EntityManager $entityManager, NoticeRepository $noticeRepository)
    {
        $this->entityManager = $entityManager;
        $this->noticeRepository = $noticeRepository;
    }

    public function findNotice()
    {
        return $this->noticeRepository->getNoticeRecords();
    }

    public function createNotice($data)
    {
        $environment = InstanceProvider::getLibEnvironment();

        $nrorg = $environment->getCurrentOrganizationId();
        $newCodeService = InstanceProvider::getService()->getNewCode();

        $id = $newCodeService->getCodeByTableName('INFORMATIVOECOMMERCE', $nrorg, 1, 10, true);

        $data['id'] = $id;
        $data['dateBegin'] = $data['dateBegin'] . ' 00:00:00';
        $data['dateEnd'] = $data['dateEnd'] . ' 00:00:00';

        $this->noticeRepository->insertNotice($data);
    }

    public function deleteNotice($ids)
    {
        $this->noticeRepository->deleteNotice($ids);
    }

    public function updateNotice($data)
    {
        for ($i = 0; $i < sizeof($data); $i++) {
            $data[$i]['dateBegin'] = $data[$i]['dateBegin'] . ' 00:00:00';
            $data[$i]['dateEnd'] = $data[$i]['dateEnd'] . ' 00:00:00';
        }

        $this->noticeRepository->updateNotice($data);
    }
}
