/* Sistemas Integrados TEKNISA
  Integrao TEKNISA X SAP

Nome: 0005_LAVFUNO.SQL

@C:\Web_505\Xdb\Src\Cli\LAV\SQL\0005_LAVFUNO_USR_CPAG_DOC_LAVOR.SQL

Descrio:
Rotina para retornar a condio de pagamento do documento (nota fiscal).

P_CDFILIAL   - Cdigo da filial de lanamento
P_NRLANCTONF - Nmero de lanamento da nota fiscal
P_IDORIGEM   - Origem (F-Fornecedor / C-Cliente)

Criao:
05/01/2009 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE FUNCTION USR_CPAG_DOC_LAVOR
   (P_CDFILIAL   IN  FILIAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN  NOTAFISCAL.NRLANCTONF%TYPE,
    P_IDORIGEM   IN  USR_CONDPGTOSAP.USR_IDORIGEM%TYPE) RETURN VARCHAR
IS
   V_DIASPGTO   VARCHAR2(100);
   V_RESULT     VARCHAR2(12);
   V_COUNT      NUMBER;
   V_DTVENC     VARCHAR2(08);
BEGIN
   V_DIASPGTO := NULL;
   V_RESULT   := NULL;
   V_COUNT    := 0;
   V_DTVENC   := NULL;

   IF P_IDORIGEM = 'F' THEN
      FOR C_DIAS IN (SELECT TO_CHAR(QTDIASVENPAG) AS NRDIASPGTOFO
                       FROM CONTAPAGAR
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NRLANCTONF = P_NRLANCTONF
                      ORDER BY QTDIASVENPAG) LOOP

         V_DIASPGTO := V_DIASPGTO || C_DIAS.NRDIASPGTOFO;

         V_COUNT := V_COUNT + 1;
      END LOOP;

      IF V_COUNT <> 1 THEN
         SELECT SUBSTR(MIN(USR_CDFORMPGTO),1,4)
           INTO V_RESULT
           FROM USR_CONDPGTOSAP
          WHERE USR_IDORIGEM = P_IDORIGEM
            AND USR_DSDIASPGTO = V_DIASPGTO;
     ELSE
         SELECT RPAD(NVL(TO_CHAR(MAX(DTATUAVENPAG),'DDMMYYYY'),' '),8,' ')
           INTO V_DTVENC
           FROM CONTAPAGAR
          WHERE CDFILIAL = P_CDFILIAL
            AND NRLANCTONF = P_NRLANCTONF;

        V_RESULT := 'YF00'||V_DTVENC;
     END IF;
   ELSE
      FOR C_DIAS IN (SELECT TO_CHAR(C.DTATUAVENREC - N.DTEMISSAO) AS NRDIASPGTOCLI
                       FROM CONTARECEBER C, NOTAFISCAL N
                      WHERE N.CDFILIAL = P_CDFILIAL
                        AND N.NRLANCTONF = P_NRLANCTONF
                        AND C.CDFILIAL = N.CDFILIAL
                        AND C.NRLANCTONF = N.NRLANCTONF
                      ORDER BY C.NRSEQVENREC, C.NRPARCELAREC) LOOP

         V_DIASPGTO := V_DIASPGTO || C_DIAS.NRDIASPGTOCLI;

         V_COUNT := V_COUNT + 1;
      END LOOP;

      IF V_COUNT <> 1 THEN
         SELECT SUBSTR(MIN(USR_CDFORMPGTO),1,4)
           INTO V_RESULT
           FROM USR_CONDPGTOSAP
          WHERE USR_IDORIGEM = P_IDORIGEM
            AND USR_DSDIASPGTO = V_DIASPGTO;
      ELSE
         SELECT RPAD(NVL(TO_CHAR(MAX(DTATUAVENREC),'DDMMYYYY'),' '),8,' ')
           INTO V_DTVENC
           FROM CONTARECEBER
          WHERE CDFILIAL = P_CDFILIAL
            AND NRLANCTONF = P_NRLANCTONF;

         V_RESULT := 'ZF00'||V_DTVENC;
      END IF;
   END IF;

   RETURN(V_RESULT);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_CPAG_DOC_LAVOR','5.05.058'); END;
/

