CREATE OR REPLACE
PROCEDURE IMP_COMP_SERVMANU(
P_CDFILIAL1  IN ESPEPROD.CDFILIAL %TYPE,   -- Filial origem.
P_CDCIA1     IN ESPEPROD.CDCIA    %TYPE,   -- Companhia origem.
P_CDMANCIA1  IN ESPEPROD.CDMANCIA %TYPE,   -- Manual origem.
P_CDSERVICO1 IN ESPEPROD.CDPRODUTO%TYPE,   -- Servio origem.
P_CDCLASSE1  IN PRODUTO.CDCLASSE  %TYPE,   -- Classe origem.
P_CDCICLO1   IN PRODUTO.CDCICLO   %TYPE,   -- Ciclo origem.
P_CDSUBGRU   IN VARCHAR2 DEFAULT 'T',      -- Lista dos SubGrupos do servico. Se 'T' traz todos os subgrupos do servico informado
P_CDFILIAL2  IN ESPEPROD.CDFILIAL %TYPE,   -- Filial destino.
P_CDCIA2     IN ESPEPROD.CDCIA    %TYPE,   -- Companhia destino.
P_CDMANCIA2  IN ESPEPROD.CDMANCIA %TYPE,   -- Manual destino.
P_CDSERVICO2 IN ESPEPROD.CDPRODUTO%TYPE,   -- Servio destino.
P_CDCLASSE2  IN PRODUTO.CDCLASSE  %TYPE,   -- Classe destino.
P_CDCICLO2   IN PRODUTO.CDCICLO   %TYPE,   -- Ciclo destino.
P_CDOPERADOR IN OPERADOR.CDOPERADOR %TYPE, -- Operador
P_IDIMPCOMP  IN NUMERIC)
AS
V_DTINIVG DATE;
V_DTFIMVG DATE;
V_CDPRODUTO1  ESPEPROD.CDPRODUTO %TYPE;
V_CDESPEPROD1 ESPEPROD.CDESPEPROD%TYPE;
V_CDPRODUTO2  ESPEPROD.CDPRODUTO %TYPE;
V_CDESPEPROD2 ESPEPROD.CDESPEPROD%TYPE;
V_CONT INTEGER;
V_CDESPPRODAUX  COMPPROD.CDESPPRODAUX%TYPE;
V_CDESPPRODAUX2 COMPPROD.CDESPPRODAUX%TYPE;
BEGIN
   SELECT CDPRODUTO,CDESPEPROD
   INTO V_CDPRODUTO1,V_CDESPEPROD1
   FROM ESPEPROD
   WHERE (CDFILIAL   = P_CDFILIAL1 ) AND
         (CDCIA      = P_CDCIA1    ) AND
         (CDMANCIA   = P_CDMANCIA1 ) AND
         (CDPRODUTO  = P_CDSERVICO1) AND
         (IDTPMANUAL = 'M'         );
   SELECT CDPRODUTO,CDESPEPROD
   INTO V_CDPRODUTO2,V_CDESPEPROD2
   FROM ESPEPROD
   WHERE (CDFILIAL   = P_CDFILIAL2 ) AND
         (CDCIA      = P_CDCIA2    ) AND
         (CDMANCIA   = P_CDMANCIA2 ) AND
         (CDPRODUTO  = P_CDSERVICO2) AND
         (IDTPMANUAL = 'M'         );
   IF P_IDIMPCOMP = 1 THEN
      -- DELETANDO PRODUTOS E RECEITAS DESTINO
      FOR C_COMPPROD IN (SELECT CP.CDPRODUTO, CP.CDESPEPROD, CP.CDTIPOCOMP, CP.CDPRODINSUMO
                         FROM COMPPROD CP
                         WHERE
                            (CP.CDPRODUTOAUX = V_CDPRODUTO2) AND
                            (CP.CDESPPRODAUX = V_CDESPEPROD2)) LOOP
         DELETE FROM COMPPROD
         WHERE
             (CDPRODUTO    = C_COMPPROD.CDPRODUTO   ) AND
             (CDESPEPROD   = C_COMPPROD.CDESPEPROD  ) AND
             (CDTIPOCOMP   = C_COMPPROD.CDTIPOCOMP  ) AND
             (CDPRODINSUMO = C_COMPPROD.CDPRODINSUMO);
      END LOOP;
      -- DELETANDO SUBGRUPOS
      FOR C_SUBGRU IN (SELECT CDPRODUTO, CDESPEPROD,
                              CDTIPOCOMP, CDPRODINSUMO
                       FROM COMPPROD
                       WHERE
                          (CDPRODUTO    = V_CDPRODUTO2   ) AND
                          (CDESPEPROD   = V_CDESPEPROD2  ) AND
                          ((INSTR(P_CDSUBGRU, '_'||CDPRODINSUMO||'_') <> 0) OR (P_CDSUBGRU = 'T'))) LOOP
         DELETE FROM COMPPROD
         WHERE
             (CDPRODUTO    = C_SUBGRU.CDPRODUTO   ) AND
             (CDESPEPROD   = C_SUBGRU.CDESPEPROD  ) AND
             (CDTIPOCOMP   = C_SUBGRU.CDTIPOCOMP  ) AND
             (CDPRODINSUMO = C_SUBGRU.CDPRODINSUMO);
      END LOOP;
   END IF;
   -- TODOS OS SUBGRUPOS DE ORIGEM
   FOR C_COMP IN (SELECT CDTIPOCOMP,IDUTAPROVREQ,CDPRODINSUMO,CDESPEPROD,
                         CDPRODUTOAUX,CDESPPRODAUX,QTINSUMO,
                         VRLOADCOMP,TXCOMITCOMP,NRORDCOMP
                  FROM COMPPROD
                  WHERE
                     (CDPRODUTO    = V_CDPRODUTO1   ) AND
                     (CDESPEPROD   = V_CDESPEPROD1  ) AND
                     ((INSTR(P_CDSUBGRU, '_'||CDPRODINSUMO||'_') <> 0) OR (P_CDSUBGRU = 'T'))) LOOP
      SELECT COUNT(*)
      INTO V_CONT
      FROM COMPPROD
      WHERE (CDPRODUTO    = V_CDPRODUTO2       ) AND
            (CDESPEPROD   = V_CDESPEPROD2      ) AND
            (CDPRODINSUMO = C_COMP.CDPRODINSUMO);
      -- ACRESCENTAR
      IF V_CONT = 0 THEN
         SELECT LPAD(TO_CHAR(NVL(MAX(CDESPEPROD),0)+1),10,'0')
         INTO V_CDESPPRODAUX
         FROM ESPEPROD
         WHERE (CDPRODUTO = C_COMP.CDPRODUTOAUX);
         --  IMPORTAR O SUB GRUPO
         INSERT INTO ESPEPROD
            (CDPRODUTO, CDESPEPROD,NMESPEPROD,DTVALESPEPRO,DTINCESPEPRO,
             CDFILIAL, CDCIA, CDMANCIA,IDTPMANUAL,CDOPERADOR)
         VALUES
            (C_COMP.CDPRODINSUMO, V_CDESPPRODAUX,'ESPECIFICACAO PADRAO'||V_CDESPPRODAUX, TRUNC(SYSDATE),TRUNC(SYSDATE),
             P_CDFILIAL2, P_CDCIA2, P_CDMANCIA2,'M', P_CDOPERADOR);
         INSERT INTO COMPPROD
            (CDPRODUTO,CDESPEPROD,CDTIPOCOMP,IDUTAPROVREQ,
             CDPRODINSUMO,CDPRODUTOAUX,CDESPPRODAUX,QTINSUMO,
             VRLOADCOMP,TXCOMITCOMP,NRORDCOMP)
         VALUES
            (P_CDSERVICO2, V_CDESPEPROD2, C_COMP.CDTIPOCOMP, C_COMP.IDUTAPROVREQ,
             C_COMP.CDPRODINSUMO,C_COMP.CDPRODUTOAUX,V_CDESPPRODAUX,C_COMP.QTINSUMO,
             C_COMP.VRLOADCOMP,C_COMP.TXCOMITCOMP,C_COMP.NRORDCOMP);
         -- IMPORTAR OS PRODUTOS E AS RECEITAS
         INSERT INTO COMPPROD
            (CDPRODUTOAUX,CDESPPRODAUX,CDPRODINSUMO,
             CDPRODUTO,CDESPEPROD,IDUTAPROVREQ,CDTIPOCOMP,
             SGUNIDADE,QTINSUMO,TXCOMITCOMP,VRLOADCOMP,NRORDCOMP)
         SELECT P_CDSERVICO2, V_CDESPEPROD2, CP.CDPRODINSUMO,
                C_COMP.CDPRODUTOAUX,V_CDESPPRODAUX,CP.IDUTAPROVREQ,CP.CDTIPOCOMP,
                CP.SGUNIDADE,CP.QTINSUMO,CP.TXCOMITCOMP,CP.VRLOADCOMP,CP.NRORDCOMP
         FROM COMPPROD CP
         WHERE (CP.CDPRODUTOAUX = P_CDSERVICO1       ) AND
               (CP.CDESPPRODAUX = V_CDESPEPROD1      ) AND
               (CP.CDPRODUTO    = C_COMP.CDPRODUTOAUX) AND
               (CP.CDESPEPROD   = C_COMP.CDESPPRODAUX) AND
               (NOT EXISTS (SELECT *
                            FROM COMPPROD CO
                            WHERE (CO.CDPRODUTOAUX = P_CDSERVICO2       ) AND
                                  (CO.CDESPPRODAUX = V_CDESPEPROD2      ) AND
                                  (CO.CDPRODUTO    = C_COMP.CDPRODUTOAUX) AND
                                  (CO.CDESPEPROD   = V_CDESPPRODAUX     ) AND 
                                  (CO.CDPRODINSUMO = CP.CDPRODINSUMO    ) AND
                                  (CO.CDTIPOCOMP   = CP.CDTIPOCOMP      )));
      ELSE
         SELECT CDESPPRODAUX
         INTO V_CDESPPRODAUX2
         FROM COMPPROD
         WHERE
            (CDPRODUTO    = P_CDSERVICO2       ) AND
            (CDESPEPROD   = V_CDESPEPROD2      ) AND
            (CDPRODINSUMO = C_COMP.CDPRODINSUMO);
          INSERT INTO COMPPROD
            (CDPRODUTOAUX,CDESPPRODAUX,CDPRODINSUMO,
             CDPRODUTO,CDESPEPROD,IDUTAPROVREQ,CDTIPOCOMP,
             SGUNIDADE,QTINSUMO,TXCOMITCOMP,VRLOADCOMP,NRORDCOMP)
         SELECT P_CDSERVICO2, V_CDESPEPROD2, CP.CDPRODINSUMO,
                C_COMP.CDPRODUTOAUX,V_CDESPPRODAUX2,CP.IDUTAPROVREQ,CP.CDTIPOCOMP,
                CP.SGUNIDADE,CP.QTINSUMO,CP.TXCOMITCOMP,CP.VRLOADCOMP,CP.NRORDCOMP
         FROM COMPPROD CP
         WHERE (CP.CDPRODUTOAUX = P_CDSERVICO1       ) AND
               (CP.CDESPPRODAUX = V_CDESPEPROD1      ) AND
               (CP.CDPRODUTO    = C_COMP.CDPRODUTOAUX) AND
               (CP.CDESPEPROD   = C_COMP.CDESPPRODAUX) AND
               (NOT EXISTS (SELECT *
                            FROM COMPPROD CO
                            WHERE (CO.CDPRODUTOAUX = P_CDSERVICO2       ) AND
                                  (CO.CDESPPRODAUX = V_CDESPEPROD2      ) AND
                                  (CO.CDPRODUTO    = C_COMP.CDPRODUTOAUX) AND
                                  (CO.CDESPEPROD   = V_CDESPPRODAUX2    ) AND
                                  (CO.CDPRODINSUMO = CP.CDPRODINSUMO    ) AND
                                  (CO.CDTIPOCOMP   = CP.CDTIPOCOMP      )));
      END IF;
   END LOOP;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('IMP_COMP_SERVMANU','5.01.001'); END;
/

