import moment from 'moment';
import { OMInstance } from '@/services/OMInstance';
import { TekRestDatasource } from '@zeedhi/teknisa-components-common';

export class CollectionErrorsController {
    public filterDate: any;

    public onCreatedCollectionErrorsGrid() {
        const isAppliedFilter = false;
        if (!isAppliedFilter) {
            const today = moment().format('DD/MM/YYYY');
            const fiveDays = moment().subtract(5, 'days').format('DD/MM/YYYY');
            this.filterDate = [fiveDays, today];
            const grid = OMInstance.getInstanceTekGrid('collectionErrors-grid');
            (grid.datasource as TekRestDatasource).dynamicFilter = {
                DTINCLUSAO: [{
                    relation: 'AND',
                    operation: 'BETWEEN',
                    value: [fiveDays, today],
                }],
            };
            grid.datasource.get();
        }
    }
}
